/* eslint-disable @typescript-eslint/no-empty-interface */
// Generated code for namespace: org.accordproject.cicero.dom

// imports
import {IAccordParty} from './org.accordproject.cicero.contract';
import {IConcept,IAsset} from './concerto';

// interfaces
export interface IMetadata extends IConcept {
   version: string;
   locale: string;
}

export interface IElement extends IAsset {
   id: string;
}

export interface IContractTemplate extends IElement {
   metadata: IMetadata;
   content?: ISection;
}

export interface IClauseTemplate extends IElement {
   metadata: IMetadata;
   content?: ISection;
}

export interface IText extends IElement {
   content: string;
   locale?: string;
}

export interface IParameter extends IElement {
   name: string;
   description?: string;
   type?: string;
   constraint?: IBooleanExpression;
}

export interface IChoice extends IElement {
   options: IElement[];
   required: boolean;
}

export interface IConditional extends IElement {
   element: IElement;
   predicate: IBooleanExpression;
}

export interface IClause extends IElement {
   templateUri: string;
}

export interface ISigningParty extends IConcept {
   description: IText;
   party: IAccordParty;
}

export interface ISignatures extends IElement {
   parties: ISigningParty[];
}

export interface ILink extends IElement {
   reference: IElement;
}

export interface ISection extends IElement {
   heading: IText;
   children?: IElement[];
   pageBreak: boolean;
}

export enum ListStyle {
   ORDERED = 'ORDERED',
   UNORDERED = 'UNORDERED',
   SINGLE_LINE = 'SINGLE_LINE',
}

export interface IList extends ISection {
   style: ListStyle;
   separator?: string;
}

export interface IScript extends IElement {
   language: string;
   version: string;
   code: string;
}

export interface IDeclarations extends IScript {
}

export interface IExpression extends IScript {
}

export interface IElementExpression extends IExpression {
}

export interface IBooleanExpression extends IExpression {
}

